| The Gaudi Framework v29r1 (5cd95fa2)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Private Member Functions | List of all members
Gaudi::Functional::Producer< std::tuple< Out... >(), Traits_ > Class Template Referenceabstract

`#include <GaudiAlg/Producer.h>`

Inheritance diagram for Gaudi::Functional::Producer< std::tuple< Out... >(), Traits_ >:
[legend]
Collaboration diagram for Gaudi::Functional::Producer< std::tuple< Out... >(), Traits_ >:
[legend]

## Public Member Functions
StatusCode | execute () override final
virtual std::tuple< Out... > | operator() () const =0
Public Member Functions inherited from Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, void, Traits_ >
| DataHandleMixin (const std::string &name, ISvcLocator *pSvcLocator, const std::array< KeyValue, N_out > &outputs)
| DataHandleMixin (const std::string &name, ISvcLocator *locator, const KeyValue &output)
template<std::size_t N = 0>
const std::string & | outputLocation () const
unsigned int | outputLocationSize () const

## Private Member Functions
template<std::size_t... O>
StatusCode | invoke (std::index_sequence< O... >)

## Additional Inherited Members
Public Types inherited from Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, void, Traits_ >
using | KeyValue = std::pair< std::string, std::string >
Static Public Attributes inherited from Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, void, Traits_ >
static constexpr std::size_t | N_out = sizeof...( Out )
Protected Attributes inherited from Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, void, Traits_ >
std::tuple< details::OutputHandle_t< Traits_, Out >... > | m_outputs

## Detailed Description

### template<typename... Out, typename Traits_>
class Gaudi::Functional::Producer< std::tuple< Out... >(), Traits_ >

Definition at line 17 of file Producer.h.

## Member Function Documentation

template<typename... Out, typename Traits_ >

StatusCode Gaudi::Functional::Producer< std::tuple< Out... >(), Traits_ >::execute | ( |  | ) |
| inline final override

Definition at line 23 of file Producer.h.

23 { return invoke( std::index_sequence_for<Out...>{} ); }
Gaudi::Functional::Producer< std::tuple< Out... >(), Traits_ >::invoke
StatusCode invoke(std::index_sequence< O... >)
Definition: Producer.h:30
template<typename... Out, typename Traits_ >
template<std::size_t... O>

StatusCode Gaudi::Functional::Producer< std::tuple< Out... >(), Traits_ >::invoke | ( | std::index_sequence< O... > |  | ) |
| inline private

Definition at line 30 of file Producer.h.

31 {
32 using details::as_const;
33 using details::put;
34 try {
35 std::initializer_list<int>{
36 ( put( std::get<O>( this->m_outputs ), std::get<O>( as_const( *this )() ) ), 0 )...};
37 } catch ( GaudiException& e ) {
38 ( e.code() ? this->warning() : this->error() ) << e.message() << endmsg;
39 return e.code();
40 }
41 return StatusCode::SUCCESS;
42 }
StatusCode::SUCCESS
Definition: StatusCode.h:31
Gaudi::Functional::details::as_const
constexpr std::add_const< T >::type & as_const(T &t) noexcept
Definition: FunctionalDetails.h:104
GaudiException
Define general base for Gaudi exception.
Definition: GaudiException.h:22
GaudiException::code
virtual const StatusCode & code() const
StatusCode for Exception.
Definition: GaudiException.h:119
Gaudi::Functional::details::DataHandleMixin< std::tuple< Out... >, void, Traits_ >::m_outputs
std::tuple< details::OutputHandle_t< Traits_, Out >... > m_outputs
Definition: FunctionalDetails.h:574
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
std::initializer_list
Gaudi::Functional::details::put
Out1 * put(DataObjectHandle< Out1 > &out_handle, Out2 &&out)
Definition: FunctionalDetails.h:116
template<typename... Out, typename Traits_ >

virtual std::tuple<Out...> Gaudi::Functional::Producer< std::tuple< Out... >(), Traits_ >::operator() | ( |  | ) | const
| pure virtual

The documentation for this class was generated from the following file:

- GaudiAlg/GaudiAlg/Producer.h